<!DOCTYPE html>
	<html>
		<head>
			<meta name="viewport" content="initial-scale=1.0, user-scalable=no">
			<meta http-equiv="X-UA-Compatible" content="IE=edge">
			<meta charset="utf-8">
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<title>Consume Webhook Data API - Sounds Essential LLC</title>

		</head>
            
		<body>
            <?php

				// This sample file was created by Sounds Essential LLC - for more information visit https://www.soundsessential.com/blog/193-consuming-a-webhook-with-filemaker

                // Function to get an authorization token from FileMaker which will be used to pass data from the webhook to the database - note, environment variables are set just before function is called
				function get_token($additionalHeaders,$host,$password,$payload,$username) {

					// Set up the cURL options
					$ch = curl_init($host);
					curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', $additionalHeaders));
					curl_setopt($ch, CURLOPT_HEADER, 0);
					curl_setopt($ch, CURLOPT_USERPWD, $username . ":" . $password);
					curl_setopt($ch, CURLOPT_TIMEOUT, 30);
					curl_setopt($ch, CURLOPT_POST, 1);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					
					// Execute the cURL statement
					$result = curl_exec($ch);

					// Close the cURL connection
					curl_close($ch);

					// Decode the resulting JSON
					$json_token = json_decode($result, true);

					// Extract just the token value from the JSON result
					$token_received = $json_token['response']['token'];
					
					// Return the token
					return($token_received);

				};


                // Function to pass data from the webhook to the database using the token from the function above - note, environment variables are set just before function is called
				function pass_data($additionalHeaders,$host,$payload) {
					
					// Set up the cURL options
					$ch = curl_init($host);
					// Inject the token into the header
					curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', $additionalHeaders )); 
					curl_setopt($ch, CURLOPT_HEADER, 0);
					curl_setopt($ch, CURLOPT_TIMEOUT, 30);
                    curl_setopt($ch, CURLOPT_POST, 1); 
					curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

					// Execute the cURL statement
					$result = curl_exec($ch);
					
					// Close the cURL connection
					curl_close($ch); 

					// Return the result
                    return($result);

				};


                // Function to delete the authorization token
                function delete_token($additionalHeaders,$host,$payload) {

					// Set up the cURL options
                    $ch = curl_init($host);
                    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', $additionalHeaders));
                    curl_setopt($ch, CURLOPT_HEADER, 0);
					curl_setopt($ch, CURLOPT_TIMEOUT, 30);
					// Specify the request method as DELETE
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE'); 
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					
					// Execute the cURL statement
					$result = curl_exec($ch); 
					
					// Close the cURL connection
                    curl_close($ch); 

                    // Return the result
                    return($result);

                };


				// Set up the environment variables for the hostname, database, layout, script and field name
				$database = 'DATABASE_NAME';
				$hostname = 'MY.SERVER.COM';
				$layout = 'DATA_API_LAYOUT';
				$script = 'SCRIPT_TO_EXECUTE';
				$field_name = 'FIELD_NAME';
				// Set up the FileMaker username and password that has Data API privileges
				$username = 'USERNAME';
				$password = 'PASSWORD';

				// Set up the environment variables to get a token
				$additionalHeaders = '';
				$host = 'https://'.$hostname.'/fmi/data/v1/databases/'.$database.'/sessions';
				$payload = '';
				
				// Call the get_token function and put the result into a variable for use in the pass_data function
				$token = get_token($additionalHeaders,$host,$password,$payload,$username);

				// Get the data from the webhook
                $data = (!empty(file_get_contents('php://input')) ? file_get_contents('php://input') : json_encode($_REQUEST)) ;

                // Now that we have a token, set up the environment variables and call the pass_data function to create a record and then run a script
				$additionalHeaders = 'Authorization: Bearer '.$token;
				$host = 'https://'.$hostname.'/fmi/data/v1/databases/'.$database.'/layouts/'.$layout.'/records';
				$payload = json_encode(array('fieldData' => array( $field_name => $data ), 'script' => $script, 'script.param' => $data ));
				
				// Call the pass_data function
				$request = pass_data($additionalHeaders,$host,$payload);

				// Set up the environment variables to delete the token
				$additionalHeaders = '';
				$host = 'https://'.$hostname.'/fmi/data/v1/databases/'.$database.'/sessions/'.$token;
                $payload = '';

				// Call the delete function
				$token_deleted = delete_token($additionalHeaders,$host,$payload);

            ?>

		</body>
	</html>